Unit QSS1R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTQS10_p;

procedure QSS1R(var INT :Real; A :Real; B :Real; F :Func_F1; E :Real;
                var K :Integer; var IERR :Integer);

implementation

procedure QSS1R(var INT :Real; A :Real; B :Real; F :Func_F1; E :Real;
                var K :Integer; var IERR :Integer);
var
C,D,G,H :Integer;
U,S,R,J,L,M :Real;
const
K1E9 :Real = 1.0E9;
KMAX :Integer = 1048576;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16;
begin
IERR := 0;
K := Abs(K);
if ( K  = 0 ) 
 then goto _16;
C := 0;
_1:
if ( C ) < 0
 then goto _3
 else if ( C ) > 0
       then goto _3
       else goto _2;
_2:
D := 0;
U := 0.0;
L := B-A;
J := F(A)+F(B);
_3:
M := L/K;
if ( D ) < 0
 then goto _6
 else if ( D ) > 0
       then goto _6
       else goto _4;
_4:
H := K-1;
if ( H  = 0 ) 
 then goto _6;
for G:=1 to H do
 begin
  U := U+F(A+G*M);
_5:
 end;
_6:
if ( D-1 ) < 0
 then goto _9
 else if ( D-1 ) > 0
       then goto _7
       else goto _7;
_7:
U := F(A+M);
H := (K-2) div 2;
if ( H  = 0 ) 
 then goto _9;
for G:=1 to H do
 begin
  U := U+F(A+(2*G+1)*M);
_8:
 end;
_9:
J := 2.0*U+J;
U := J*M/2.0;
D := D+1;
if ( D-1 ) < 0
 then goto _11
 else if ( D-1 ) > 0
       then goto _11
       else goto _10;
_10:
K := 2*K;
R := U;
goto _3;
_11:
if ( Abs(U-R)-K1E9 ) < 0
 then goto _12
 else if ( Abs(U-R)-K1E9 ) > 0
       then goto _10
       else goto _12;
_12:
INT := U;
INT := (4.0*INT-R)/3.0;
if ( E ) < 0
 then goto _16
 else if ( E ) > 0
       then goto _13
       else goto _16;
_13:
C := C+1;
if ( C-1 ) < 0
 then goto _15
 else if ( C-1 ) > 0
       then goto _15
       else goto _14;
_14:
K := 2*K;
S := INT;
R := U;
if ( K  < KMAX ) 
 then goto _1;
K := KMAX;
IERR := 65;
UTQS10(IERR,1);
goto _16;
_15:
if ( Abs(INT-S)-E ) < 0
 then goto _16
 else if ( Abs(INT-S)-E ) > 0
       then goto _14
       else goto _16;
_16:
end;

end.
